/*
* Template: src/main/takatuka/templates/EntityPresentationAbstractSearchView.vm
*/
package de.ivu.elect.presentation.ergebnis;

import java.util.List;

import javax.annotation.PostConstruct;
import javax.enterprise.context.RequestScoped;
import javax.enterprise.event.Observes;
import javax.enterprise.event.Reception;
import javax.enterprise.inject.Instance;
import javax.faces.context.FacesContext;
import javax.inject.Inject;
import javax.inject.Named;

import org.apache.deltaspike.core.api.scope.ConversationGroup;
import org.apache.deltaspike.core.api.scope.ViewAccessScoped;

import de.ivu.elect.business.security.UseCasePermission;

import de.ivu.elect.business.ergebnis.boundary.AbstractErgebnisSearchParameters;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisChangeEvent;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisConversationStore;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisExtendedDAO;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSearch;
import de.ivu.elect.business.ergebnis.boundary.ErgebnisSearchParameters;
import de.ivu.elect.business.wahl.boundary.WahlSelectChangeEvent;
import de.ivu.elect.business.wahl.boundary.WahlterminSelectChangeEvent;
import de.ivu.elect.business.ergebnis.entity.Ergebnis;
import de.ivu.elect.business.ergebnis.entity.ErgebnisMeta;
import de.ivu.elect.jee.entity.EagerLoadingCollector;
import de.ivu.elect.presentation.AbstractElectSearchView;
import de.ivu.elect.presentation.View;

@ViewAccessScoped
@Named(AbstractErgebnisSearchView.COMPONENT_NAME)
@View(viewId = AbstractErgebnisSearchView.VIEW_ID, useCase = UseCasePermission.ERGEBNIS_SEARCH)
public abstract class AbstractErgebnisSearchView extends AbstractElectSearchView<Ergebnis> {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ergebnisSearchView";
  
  public static final String VIEW_ID = "/ergebnis/ergebnis-search.xhtml";

  @Inject
  private transient RequestHandlerAbstractErgebnisSearchView requestHandler;

  @Inject
  private transient ErgebnisExtendedDAO extendedDAO;

  @Inject
  @ConversationGroup(ErgebnisConversationStore.class)
  protected transient ErgebnisConversationStore conversationStore;

  @Inject
  protected transient ErgebnisSearch search;

  @Inject
  @ConversationGroup(AbstractErgebnisSearchParameters.class)
  protected transient ErgebnisSearchParameters searchParameters;

  @Inject
  protected transient ErgebnisMeta entityMeta;

  public AbstractErgebnisSearchView() {
    super();
  }

  @Override
  protected String getViewId() {
    return VIEW_ID;
  }

  public boolean isEntitySelected() {
    return conversationStore.getEntityPK() != null;
  }

  public Ergebnis getSelectedEntity() {
    if (isEntitySelected()) {
      return extendedDAO.findByPrimaryKey(conversationStore.getEntityPK());
    }

    return null;
  }

  public void setSelectedEntity(Ergebnis entity) {
    if (entity == null) {
      conversationStore.setEntityPK(null);
    } else {
      conversationStore.setEntityPK(entity.getPk());
    }
  }

  @Override
  public ErgebnisSearchParameters getSearchParameters() {
    return searchParameters;
  }

  public EagerLoadingCollector<Ergebnis> getEagerLoadingCollector() {
    return EagerLoadingCollector.<Ergebnis> create();
  }

  @Override
  public List<Ergebnis> getSearchResult() {
    requestHandler.nothing(); // ELECT-248

    return super.getSearchResult();
  }

  @Override
  protected List<Ergebnis> performSearch() {
    return search.getSearchResult(getSearchParameters(), getEagerLoadingCollector());
  }

  public void onErgebnisChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) ErgebnisChangeEvent event) {
    resetSearchResult();
  }

  // ELECT-2231    ELECT-2250
  /*
   * searchParameters sind von der zur Bearbeitung ausgewählten Wahl abhängig.
   */
  public void onWahlSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlSelectChangeEvent event) {
    reset();
  }

  /*
   * searchParameters sind vom zur Bearbeitung ausgewählten Wahltermin abhängig.
   */
  public void onWahlterminSelectChangeEvent(@Observes(notifyObserver = Reception.IF_EXISTS) WahlterminSelectChangeEvent event) {
    reset();
  }

  @RequestScoped
  // elect: Das Suchergebnis soll nur einmal pro Request geladen werden, daher gibt es dieses "Konstrukt" aus "SearchView" und "RequestHandlerAbstract"
  public static class RequestHandlerAbstractErgebnisSearchView {

    @View
    @Inject
    private transient Instance<AbstractErgebnisSearchView> searchViews;

    @PostConstruct
    public void init() {
      // ELECT-3543 Doppelte Suchen vermeiden - Suchergebnis für Request nicht beim POST-löschen
      if (!FacesContext.getCurrentInstance().isPostback()) {
        for (AbstractErgebnisSearchView searchView : searchViews) {
          searchView.resetSearchResult();
        }
      }
    }

    public void nothing() {
      // Do nothing.
    }
  }
}
